package com.fp.frontend.controller.armas.solicitud;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.parmas.soli.TarmDetRepDestruirArmas;

/**
 * Clase controladora del bean TarmDetRepDestruirArmas
 *
 * @author Christian Pazmino
 * @version 2.1
 */
@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class DetRepDestruirArmasController extends AbstractController<TarmDetRepDestruirArmas> {

    public DetRepDestruirArmasController() throws Exception {
        super(TarmDetRepDestruirArmas.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();
        //Ingreso de Datos Quemados

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    public void init() {
        try {
            this.recperpage = 10; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            //	record = new TarmSolicitudImportacion();
            this.beanalias = "DETREPORTEDESTRUIRARMAS";
//			this.create();
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los
            // registros nuevos.
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = this.callerhelper.getRequest();
            msave.put(this.beanalias, dtosave); // adicionar metadata de
            // mantenimiento para cada
            // tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public static List<TarmDetRepDestruirArmas> find() {
        try {
            DetRepDestruirArmasController cc = new DetRepDestruirArmasController();
            cc.init();
            cc.recperpage = 300;
            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }

    /**
     * Metodo que busca un item de la tabla de detalle de reporte de destruccion
     * de armas mediante la clave primaria
     *
     */
    public static TarmDetRepDestruirArmas findByCodigo(String cRegistro) {
        try {
            DetRepDestruirArmasController cc = new DetRepDestruirArmasController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk", cRegistro);
            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                return cc.lrecord.get(0);
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }

    /**
     * Metodo que busca una cabecera de reporte de destruccion de armas mediante
     * el codigo de reporte
     *
     * @param cReporte codigo de reporte
     * @return Lista de objetos de tipo TarmDetRepDestruirArmas que tienen el
     * mismo cReporte
     */
    public static List<TarmDetRepDestruirArmas> findByCReporte(String cReporte) {
        try {
            DetRepDestruirArmasController cc = new DetRepDestruirArmasController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("creporte", cReporte);
            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }

    @Override
    public void postCommit(Response response) throws Exception {
        super.postCommitGeneric(response, this.beanalias);
    }

    @Override
    protected void querydatabase() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.pk"); // En en string van todos los campos de orden ("t.pk,  t.nombre, t.cpais").

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.
            request.setQueryTables(mtables);
            Response resp = this.callerhelper.executeQuery(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TarmDetRepDestruirArmas>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TarmDetRepDestruirArmas>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }

    }

    public void update(TarmDetRepDestruirArmas bean) throws Exception {
        record = bean;
        update();
    }
}
